/* 
 * Just Another Team
 */

package controller;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import model.Game;
import view.View;

public class Controller {

	// A program belepesi pontja
	public static void main(String args[]) {
		new Controller();
		System.out.println("Bankrablo started...");
	}

	// Ablak
	private JFrame f;

	// Game-re mutato referencia
	private Game game;

	// View-ra mutato referencia
	private View view;

	// Controller osztaly konstruktora
	public Controller() {

		// Title
		f = new JFrame("Bankrabl");

		// Menu
		JMenu menu;

		// Menu pont
		JMenuItem menuItem;

		// Menusor
		JMenuBar menuBar = new JMenuBar();

		// Letrehozzuk az elso menut
		menu = new JMenu("Jtk");

		// Uj jatek menupont
		menuItem = new JMenuItem("j jtk");

		// A kivalasztast lekezelo nevtelen osztaly
		menuItem.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				game.loadLevel(Game.random.nextInt(4));
			}
		});

		// Jatek menupont hozzadasa
		menu.add(menuItem);

		// Uj jatek menupont
		menuItem = new JMenuItem("Rabolok");

		// A kivalasztast lekezelo nevtelen osztaly
		menuItem.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				game.startGame();
			}
		});

		// Jatek menupont hozzaadasa
		menu.add(menuItem);
		// Uj jatek menupont
		menuItem = new JMenuItem("Sznet");
		// A kivalasztast lekezelo nevtelen osztaly
		menuItem.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				game.pause();
			}
		});
		menu.add(menuItem);

		// Segitseg menupont
		menuItem = new JMenuItem("Segtsg");
		menuItem.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				JFrame frame = new JFrame("Segtsg");
				frame
						.add(new JLabel(
								"<html>A jtk a nyilak hasznlatval indthat/jtszhat."
										+ "<br> Olvasd el az utasitsokat is. Sok sikert!</html>"));
				frame.pack();
				frame.setVisible(true);
				frame.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
			}
		});
		// Hozzadas
		menu.add(menuItem);

		// Jatek menupont hozzadasa
		menu.add(menuItem);
		// Uj jatek menupont
		menuItem = new JMenuItem("Kilps");

		// A kivalasztast lekezelo nevtelen osztaly
		menuItem.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				System.exit(0);
			}
		});

		// Jatek menupont hozzadasa
		menu.add(menuItem);

		// A menusorhoz hozzaadjuk az uj menut
		menuBar.add(menu);

		// Uj menu
		menu = new JMenu("Szint");

		// Uj szint menupont
		menuItem = new JMenuItem("Kezdo");

		// A kivalasztst lekezelo nevtelen osztly
		menuItem.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				game.loadLevel(0);
			}
		});

		// Uj menu
		menu.add(menuItem);

		// Uj szint menupont
		menuItem = new JMenuItem("Kzepes");

		// A kivalasztast lekezelo nevtelen osztaly
		menuItem.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				game.loadLevel(1);
			}
		});

		// Uj menu
		menu.add(menuItem);

		// Uj szint menupont
		menuItem = new JMenuItem("Halad");

		// A kivalasztast lekezelo nevtelen osztaly
		menuItem.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				game.loadLevel(2);
			}
		});

		// Uj menu
		menu.add(menuItem);

		// Uj szint menupont
		menuItem = new JMenuItem("Profi");

		// A kivalasztast lekezelo nevtelen osztaly
		menuItem.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				game.loadLevel(3);
			}
		});

		// Uj menu
		menu.add(menuItem);
		// Uj menupont
		menuBar.add(menu);

		f.setJMenuBar(menuBar);

		// A gombnyomasokat lekezelo nevtelen osztaly
		f.addKeyListener(new KeyAdapter() {
			@Override
			public void keyReleased(KeyEvent e) {
				switch (e.getKeyCode()) {
				// Bal gomb
				case KeyEvent.VK_LEFT:
					game.Move(3);
					break;
				// Jobb gomb
				case KeyEvent.VK_RIGHT:
					game.Move(1);
					break;
				// Fel gomb
				case KeyEvent.VK_UP:
					game.Move(0);
					break;
				// Le gomb
				case KeyEvent.VK_DOWN:
					game.Move(2);
					break;
				}
			}
		});

		// Inicializaljuk az osztalyokat
		view = new View();
		game = new Game(view);
		view.setGame(game);

		// A frame tulajdonsagai
		f.setResizable(false);
		f.add(view);
		f.pack();
		f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		f.setVisible(true);
	}
}