/* 
 * Just Another Team
 */

package model;

//CarFactory osztaly
public class CarFactory {

	// Varosra mutato referencia
	private City city;
	// Gamere mutato referencia
	private Game game;

	// Elhelyezi a rablok autojat a varosban
	public void newRunnerCar() {
		// Letrehozzuk az autot
		RunnerCar c = new RunnerCar(100, city);
		// Betesszuk a varosba
		city.newRunnerCar(c);
		// Letrehozzuk a megjelenitesert felelos objektumot
		game.getView().createRunnerCarView(c);
	}

	// Beallitja a belso tagvaltozokat
	public void setCity(Game game, City city) {
		this.city = city;
		this.game = game;
	}

	// Az ido lepteti a palyat
	public void tick() {

		// Veletlen faktor
		int rnd = Game.random.nextInt(100);

		// Bizonyos valoszinuseggel autot generalunk
		if (rnd < 7) {
			// Letrehozzuk az autot
			Car c = new Car(Game.random.nextInt(5) + 5,
					Game.random.nextInt(25) + 25, city);
			// Betesszuk a varosba
			city.newCar(c);
			// Letrehozzuk a megjelenitesert felelos objektumot
			game.getView().createCarView(c);
		}

		// Bizonyos valoszinuseggel autot generalunk
		if (7 < rnd && rnd < 9) {
			// Letrehozzuk a rendorautot
			PoliceCar c = new PoliceCar(Game.random.nextInt(5) + 5, Game.random
					.nextInt(25) + 25, city);
			// Betesszuk a varosba
			city.newCar(c);
			// Letrehozzuk a megjelenitesert felelos objektumot
			game.getView().createPoliceCarView(c);
		}
		if (rnd == 9 || rnd == 10) {
			// Letrehozzuk a nyulat
			Bunny b = new Bunny(Game.random.nextInt(20) + 20, Game.random
					.nextInt(15) + 15, city);
			// Betesszuk a varosba
			city.newBunny(b);
			// Letrehozzuk a megjelenitesert felelos objektumot
			game.getView().createBunnyView(b);
		}
	}
}
