/* 
 * Just Another Team
 */

package model;

//PoliceCar osztaly
public class PoliceCar extends Car {

	// Konstruktor
	public PoliceCar(int speed, int strength, City city) {
		super(speed, strength, city);
	}

	// Callbacket megvalosito, utkozest lekezelo fuggveny
	@Override
	public void collision(RunnerCar r) {
		r.collisionWithPolice(this);
	}

	// Lepteti a rendorautot
	@Override
	public void step() {
		// Ha meg a palyan van
		if (node != null) {
			// Varakozas csokkentese
			if (wait > 0) {
				wait--;
			}

			// Ha nincs kimeno kapcsolat, akkor vege a jateknak
			if (node.activeOutNodes() == 0) {
				this.destroy();
				return;
			}

			// Ha meg nem dontott a kovetkezo lepesrol, akkor dontunk
			if (nextMove == -1) {
				do {
					nextMove = Game.random.nextInt(4);
				} while (node.getOutNodes()[nextMove] == null);
			}

			// Ha lejart a varakozasi ido, akkor lepunk
			if (wait == 0) {
				// Kivelasztjuk a celcsomopontot
				Node target = node.getOutNodes()[nextMove];
				// Elsobbseget adunk
				if (givePriority(target)) {
					// Ha ures mezo van elol
					if (target.getCar() == null) {
						// Lepunk
						node.setCar(null);
						node.getOutNodes()[nextMove].setCar(this);
						node = node.getOutNodes()[nextMove];
						wait = speed;
						nextMove = -1;
						// Dontunk a kovetkezo lepesrol
						step();
						return;
					}
					// Ha elkapjuk a rablot
					if (target.getCar() == city.getRunnerCar()) {
						// Utzkozest lekezeljuk
						node.setCar(null);
						city.getRunnerCar().collisionWithPolice(this);
						if (node != null) {
							node.getOutNodes()[nextMove].setCar(this);
							node = node.getOutNodes()[nextMove];
						}
						wait = speed;
						nextMove = -1;
						// Dontunk a kovetkezo lepesrol
						step();
						return;
					}
				}
			}
		}
	}
}
