/* 
 * Just Another Team
 */

package model;

// RunnerCar osztaly
public class RunnerCar extends Car {

	// Nyusziero
	private int bunnyPower;

	// Konstruktor
	public RunnerCar(int strength, City city) {
		super(0, strength, city);
		bunnyPower = 0;
	}

	// Utkozest lekezeljuk a nyullal
	public void collisionWithBunny(Bunny bunny) {
		bunnyPower += bunny.getStrength();
		bunny.destroy();
	}

	// Utkozest lekezeljuk az autoval
	public void collisionWithCar(Car car) {
		// Ha nincs nyulero csokken az eletero
		if (bunnyPower == 0)
			strength = strength - car.getStrength();
		// Megvizsgaljuk, hogy tuleltek-e a rablok
		if (strength > 0)
			car.destroy();
		else {
			this.destroy();
			city.getGame().endGame();
		}
	}

	// Utkozest lekezeljuk a rendorautoval
	public void collisionWithPolice(PoliceCar policeCar) {
		// Ha nincs nyulero veszitunk
		if (bunnyPower == 0) {
			this.destroy();
			city.getGame().endGame();
		} else {
			policeCar.destroy();
		}
	}

	// Megszunteti ezt az autot
	@Override
	public void destroy() {
		strength = 0;

		node.setCar(null);
		city.removeRunnerCar();
		node = null;
	}

	// Getter fuggveny belso tagvaltozohoz
	public int getBunnyPower() {
		return bunnyPower;
	}

	// Lepteti a rablot
	public void step(int dir) {
		if (node != null) {
			// Elmentjuk megjelenites celjabol
			nextMove = dir;
			if (bunnyPower > 0) {
				bunnyPower--;
			}

			// Lekerdezzuk a ki-bemeno kapcsolatokat
			Node dirNode;
			Node[] outNodes = node.getOutNodes();
			Node[] inNodes = node.getInNodes();

			// Megnezzuk, hogy ervenyes-e
			if (outNodes[dir] != null)
				dirNode = outNodes[dir];
			else if (inNodes[dir] != null)
				dirNode = inNodes[dir];
			else
				return;

			// Ha nem ures a mezo, akkor lekezeljuk az utkozest
			if (dirNode.getCar() != null)
				dirNode.getCar().collision(this);

			// Ha maradt meg eletero
			if (strength > 0) {
				node.setCar(null);
				node = dirNode;
				dirNode.setCar(this);
			}

			// Ha bertunk a bazisra
			if (node != null && node.isHiding()) {
				city.getGame().winGame();
				this.destroy();
				return;
			}
		}
	}
}
