/* 
 * Just Another Team
 */

package view;

import java.awt.Color;
import java.awt.Graphics2D;
import model.Node;

//NodeView osztly
public class NodeView implements Paintable {

	private Node node;
	private View view;
	// Belso allapot
	private int x;
	private int y;

	// Konstrukor
	public NodeView(Node node, View view, int x, int y) {
		this.node = node;
		this.view = view;
		this.x = x;
		this.y = y;
	}

	// Kirajzolja a jelzolampat a kapott parameterekkel
	private void drawTrafficLight(Graphics2D g, Color c, int dir) {
		g.setColor(c);
		// Az iranytol fuggoen
		switch (dir) {
		case 0:
			g.fillOval(x - 7, y - 7, 7, 7);
			break;
		case 1:
			g.fillOval(x - 7 + 30, y - 7, 7, 7);
			break;
		case 2:
			g.fillOval(x - 7 + 30, y + 30 - 7, 7, 7);
			break;
		case 3:
			g.fillOval(x - 7, y - 7 + 30, 7, 7);
			break;
		}
	}

	// Getter fuggveny belso tagvaltozohoz
	public int getX() {
		return x;
	}

	// Getter fuggveny belso tagvaltozohoz
	int getY() {
		return y;
	}

	// Kirajzolja a jelzolampakat
	@Override
	public void paint(Graphics2D g) {
		if (node.getType() == 0) {
			for (int i = 0; i < 4; i++) {
				if (i == node.getTrafficLight())
					drawTrafficLight(g, Color.green, i);
				else if (node.getInNodes()[i] != null)
					drawTrafficLight(g, Color.red, i);
			}
		}
		g.setColor(Color.white);
		//g.drawRect(x, y, 25, 25);
		//g.drawString(node.getId().toString(), x, y);
	}

}
