/* 
 * Just Another Team
 */

package view;

import java.awt.Graphics2D;
import java.awt.Image;

import javax.swing.ImageIcon;
import model.PoliceCar;

//PoliceCarView osztaly
public class PoliceCarView implements Paintable {

	// Belso referenciak
	private PoliceCar policeCar;
	private View view;

	// Konstrukor
	public PoliceCarView(PoliceCar policeCar, View view) {
		this.policeCar = policeCar;
		this.view = view;
	}

	// Kirajzolja a rendorautot
	@Override
	public void paint(Graphics2D g) {
		// Ha meg nem szunt meg
		if (policeCar != null) {
			// Lekerdezzuk a csomopont azonositojat
			int nodeId = policeCar.getNodeId();
			if (nodeId != -1) {
				// A csomoponthoz tartozo megjelenitobol lekerdezzuk a
				// koordinatakat
				NodeView nodeView = view.getNodeViews().get(nodeId);
				g.translate(nodeView.getX(), nodeView.getY());
				// Elforgatjuk a kepet
				switch (policeCar.getNextMove()) {
				case 0:
					g.rotate(-Math.PI * 90 / 180, 12.5, 12.5);
					break;
				case 2:
					g.rotate(Math.PI * 90 / 180, 12.5, 12.5);
					break;
				case 3:
					g.rotate(Math.PI * 180 / 180, 12.5, 12.5);
					break;
				}
				// Kirajzoljuk a kepet
				Image icon2 = new ImageIcon("img/policecar.png").getImage();
				g.drawImage(icon2, null, null);
			}
		}
	}

}
