/* 
 * Just Another Team
 */

package view;

import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics2D;
import java.awt.Image;
import javax.swing.ImageIcon;
import model.RunnerCar;

//RunnerCarView osztaly
public class RunnerCarView implements Paintable {

	// Belso referenciak
	private RunnerCar runnerCar;
	private View view;

	// Konstrukor
	public RunnerCarView(RunnerCar runnerCar, View view) {
		this.runnerCar = runnerCar;
		this.view = view;
	}

	// Kirajzolast vegzo fuggveny
	@Override
	public void paint(Graphics2D g) {
		// Ha meg letezik a rendorauto
		if (runnerCar != null) {
			// Lekerdezzuk a csompont megjelenitojehez tartozo koordinatakat
			int nodeId = runnerCar.getNodeId();
			if (nodeId != -1) {
				// Lemasoljuk a megjelenitot
				Graphics2D g2 = (Graphics2D) g.create();
				NodeView nodeView = view.getNodeViews().get(nodeId);
				g.translate(nodeView.getX(), nodeView.getY());
				// Forgatas haladasi irany szerint
				switch (runnerCar.getNextMove()) {
				case 0:
					g.rotate(-Math.PI * 90 / 180, 12.5, 12.5);
					break;
				case 2:
					g.rotate(Math.PI * 90 / 180, 12.5, 12.5);
					break;
				case 3:
					g.rotate(Math.PI * 180 / 180, 12.5, 12.5);
					break;
				}
				// Kep kirajzolasa
				Image icon2 = new ImageIcon("img/runner.png").getImage();
				g.drawImage(icon2, null, null);
				g2.setColor(new Color(1f, 1f, 1f, 0.8f));
				// Egyeb adatok a jobb also sarokban
				g2.setFont(new Font("TimesRoman", Font.BOLD, 20));
				g2.drawString("let: " + runnerCar.getStrength(), 700, 550);
				g2.drawString("Nyuszi: " + runnerCar.getBunnyPower(), 700, 575);

			}
		}
	}
}
